% (c)2011, Thomas Galliker
% Please report updates/corrections to
% thomas_galliker@bluewin.ch
% 
% Thank you

-module(gui).
-define(width, 220).
-define(height, 220).
-define(bg, white).
-export([start/2]).
start(Id, Master) ->
    timer:sleep(10),
    spawn_link(fun() -> init(Id, Master) end).
init(Id, Master) ->
    random:seed(erlang:now()),
    %Xpos = (random:uniform(6)-1) * ?width,
    %Xpos = (erlang:now() rem 10) * 10,
    %random:seed(erlang:now()),
    Ypos = (random:uniform(3)-1) * ?height,
    %Win = gs:window(gs:start(),[{map,true},{title, Id}, {bg, ?bg},
    %				{width,?width},{height,?height},{y,Ypos},{x,Xpos}]),
    Win = gs:window(gs:start(),[{map,true},{title, Id}, {bg, ?bg},
				{width,?width},{height,?height}]),
    Xpos = gs:read(Win, x)*9 - ?width,
    %Ypos = gs:read(Win, y)*2,
    gs:config(Win, [{x,Xpos},{y,Ypos}]), 
    Canvas = gs:canvas(Win,[{width,?width},{y,?height-30},{height,30},{bg,white}]),
    gs:button(Win,[{label, {text,"Close"}},{x,?width-100},{y,?height-30}]),
    gs:create(text,Canvas,[{coords,[{0,0}]},
                  {font,{arial,10}},
                  {fg,blue},
                  {text,"www.thomasgalliker.ch"}]),
    Listbox=gs:listbox(Win,[{x,0},{y,(?width*0.25)},{width,?width},
                       {height,(?height*0.75)-30},{vscroll,right},
                       {click,false},{doubleclick,false}]),
    loop(Win, Listbox, Master).
loop(Win, Listbox, Master)->
    receive
	{color, Color} ->
	    log(Listbox, lists:flatten(io_lib:format("Color=~p", [Color]))),
	    color(Win, Color, Master),
	    loop(Win, Listbox, Master);
	{gs,_,destroy,[],[]} ->
	    Master ! stop,
	    ok;
	{gs,_,click,_,["Close"]} ->
	    Master ! stop,
	    ok;
	stop ->
	    ok;
	Error ->
	    io:format("gui: strange message ~w ~n", [Error]),
	    loop(Win, Listbox, Master)
    end.

color(Win, Color, Master) ->
    Canvas = gs:canvas(Win,[{width,?width},{height,?height*0.25},{bg,white}]),
    %gs:oval(Canvas,[{coords,[{?width-30,?height-45},{30,15}]},{fill,Color}]),
    gs:create(arc,Canvas,[{coords,[{0,0},{?width,?height}]},{start, 0},{extent, 180},{fill,Color}]),
    gs:create(text,Canvas,[{coords,[{0,0}]},
                  {font,{arial,10}},
                  {fg,blue},
                  {text,Master}]),
    gs:create(text,Canvas,[{coords,[{0,10}]},
                  {font,{arial,10}},
                  {fg,blue},
                  {text,gs:read(Win, x)}]),
    gs:create(text,Canvas,[{coords,[{0,20}]},
                  {font,{arial,10}},
                  {fg,blue},
                  {text,gs:read(Win, y)}]).
    %gs:config(Win, [{bg, Color}]).

log(Listbox, StringItem) ->
    {Date={Year,Month,Day},Time={Hour,Minutes,Seconds}} = erlang:localtime(),
    gs:config(Listbox, [{add, io_lib:format("~p:~p:~p ~p", [Hour, Minutes, Seconds, StringItem])}]),
    %io:format("~p~n", [gs:read(Listbox, size)]).
    gs:config(Listbox, [{see,  gs:read(Listbox, size)}]).
